## greenbone-security-assistant-9.0.1-1.src.tar.gz

=== CMakeLists.txt ===
# Copyright (C) 2009-2018 Greenbone Networks GmbH
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

cmake_minimum_required (VERSION 3.0)

message ("-- Configuring Greenbone Security Assistant...")

# VERSION: Set patch version for stable releases, e.g. "9.0.1",
#          unset patch version for prereleases, e.g. "9.0"
project (greenbone-security-assistant
         VERSION 9.0.1
         LANGUAGES C)

if (POLICY CMP0005)
  cmake_policy (SET CMP0005 NEW)
endif (POLICY CMP0005)

SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

if (NOT CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE Debug)
endif (NOT CMAKE_BUILD_TYPE)

## Retrieve git revision (at configure time)
include (GetGit)

if (NOT CMAKE_BUILD_TYPE MATCHES "Release")
  if (EXISTS "${CMAKE_SOURCE_DIR}/.git/")
    if (GIT_FOUND)
      Git_GET_REVISION(${CMAKE_SOURCE_DIR} ProjectRevision)
      set (GIT_REVISION "~git-${ProjectRevision}")
    else (GIT_FOUND)
      set (GIT_REVISION "~git")
    endif (GIT_FOUND)
  endif (EXISTS "${CMAKE_SOURCE_DIR}/.git/")
endif (NOT CMAKE_BUILD_TYPE MATCHES "Release")

# set if this is in prerelease status, starting at 0 before first beta release,
# unset if this is a stable release series.
# set (PROJECT_BETA_RELEASE 0)

if (GIT_REVISION)
  set (PROJECT_VERSION_GIT "${GIT_REVISION}")
else (GIT_REVISION)
  set (PROJECT_VERSION_GIT "")
endif (GIT_REVISION)

# If PROJECT_BETA_RELEASE is set to "0", the version string will be set to:
#   "major.minor+alpha"
# If PROJECT_BETA_RELEASE is set otherwise, the version string will be set to:
#   "major.minor+beta${PROJECT_BETA_RELEASE}"
# If PROJECT_BETA_RELEASE is NOT set, the version string will be set to:
#   "major.minor.patch"
if (DEFINED PROJECT_BETA_RELEASE AND NOT PROJECT_BETA_RELEASE STREQUAL "")
  if (PROJECT_BETA_RELEASE STREQUAL "0")
    set (PROJECT_VERSION_SUFFIX "+alpha")
  else (PROJECT_BETA_RELEASE STREQUAL "0")
    set (PROJECT_VERSION_SUFFIX "+beta${PROJECT_BETA_RELEASE}")
  endif (PROJECT_BETA_RELEASE STREQUAL "0")
elseif (DEFINED PROJECT_VERSION_PATCH AND NOT PROJECT_VERSION_PATCH STREQUAL "")
  set (PROJECT_VERSION_SUFFIX ".${PROJECT_VERSION_PATCH}")
endif (DEFINED PROJECT_BETA_RELEASE AND NOT PROJECT_BETA_RELEASE STREQUAL "")

set (PROJECT_VERSION_STRING "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}${PROJECT_VERSION_SUFFIX}${PROJECT_VERSION_GIT}")

set (GSAD_VERSION "${PROJECT_VERSION_STRING}")

message (STATUS "Building GSA version ${PROJECT_VERSION_STRING}")

configure_file (VERSION.in VERSION)

## make format
message (STATUS "Looking for clang-format...")
find_program (CLANG_FORMAT clang-format)

if (CLANG_FORMAT)
  message (STATUS "Looking for clang-format... ${CLANG_FORMAT}")
  add_custom_target(format COMMAND ${CLANG_FORMAT} "-i" "./gsad/src/*.c"
                    "./gsad/src/*.h" WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}")
else (CLANG_FORMAT)
  message (STATUS "clang-format not found...")
endif (CLANG_FORMAT)

## CPack configuration

set (CPACK_CMAKE_GENERATOR "Unix Makefiles")
set (CPACK_GENERATOR "TGZ")
set (CPACK_INSTALL_CMAKE_PROJECTS ".;greenbone-security-assistant;ALL;/")
set (CPACK_MODULE_PATH "")
set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE")
set (CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README.md")
set (CPACK_RESOURCE_FILE_WELCOME "${CMAKE_SOURCE_DIR}/README.md")
set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_TOPLEVEL_TAG "")
set (CPACK_SYSTEM_NAME "")
set (CPACK_TOPLEVEL_TAG "")

set (CPACK_PACKAGE_VERSION "${PROJECT_VERSION_STRING}${PROJECT_VERSION_GIT}")

set (CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${CPACK_PACKAGE_VERSION}")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${CPACK_PACKAGE_VERSION}")
set (CPACK_PACKAGE_VENDOR "Greenbone Networks")
set (CPACK_SOURCE_IGNORE_FILES
    "${CMAKE_BINARY_DIR}"
    "/.git/"
    "swp$"
)

include (CPack)

## Variables

if (NOT SYSCONFDIR)
  set (SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/etc")
endif (NOT SYSCONFDIR)

if (NOT EXEC_PREFIX)
  set (EXEC_PREFIX "${CMAKE_INSTALL_PREFIX}")
endif (NOT EXEC_PREFIX)

if (NOT BINDIR)
  set (BINDIR "${EXEC_PREFIX}/bin")
endif (NOT BINDIR)

if (NOT SBINDIR)
  set (SBINDIR "${EXEC_PREFIX}/sbin")
endif (NOT SBINDIR)

if (NOT LIBDIR)
  set (LIBDIR "${EXEC_PREFIX}/lib")
endif (NOT LIBDIR)

if (NOT LOCALSTATEDIR)
  set (LOCALSTATEDIR "${CMAKE_INSTALL_PREFIX}/var")
endif (NOT LOCALSTATEDIR)

if (NOT INCLUDEDIR)
  set (INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include")
endif (NOT INCLUDEDIR)

if (NOT DATADIR)
  set (DATADIR "${CMAKE_INSTALL_PREFIX}/share")
endif (NOT DATADIR)

if (NOT GSAD_PID_DIR)
  set (GSAD_PID_DIR "${LOCALSTATEDIR}/run")
endif (NOT GSAD_PID_DIR)

if (NOT GVM_STATE_DIR)
  set (GVM_STATE_DIR "${LOCALSTATEDIR}/lib/gvm")
else (NOT GVM_STATE_DIR)
  set (GVM_STATE_DIR "${GVM_STATE_DIR}")
endif (NOT GVM_STATE_DIR)

if (NOT GVM_LOG_DIR)
  set (GVM_LOG_DIR "${LOCALSTATEDIR}/log/gvm")
else (NOT GVM_LOG_DIR)
  set (GVM_LOG_DIR "${GVM_LOG_DIR}")
endif (NOT GVM_LOG_DIR)

set (GSAD_DATA_DIR "${DATADIR}/gvm/gsad")
set (GSAD_LOCALE_SUBDIR "locale")
set (GSAD_LOCALE_DIR "${GSAD_DATA_DIR}/${GSAD_LOCALE_SUBDIR}")
set (GSAD_CHROOT_LOCALE_DIR "/${GSAD_LOCALE_SUBDIR}")

# TODO: Eventually use own certificates
if (NOT GVM_SERVER_CERTIFICATE)
  set (GVM_SERVER_CERTIFICATE "${GVM_STATE_DIR}/CA/servercert.pem")
else (NOT GVM_SERVER_CERTIFICATE)
  set (GVM_SERVER_CERTIFICATE "${GVM_SERVER_CERTIFICATE}")
endif (NOT GVM_SERVER_CERTIFICATE)

if (NOT GVM_SERVER_KEY)
  set (GVM_SERVER_KEY "${GVM_STATE_DIR}/private/CA/serverkey.pem")
else (NOT GVM_SERVER_KEY)
  set (GVM_SERVER_KEY "${GVM_SERVER_KEY}")
endif (NOT GVM_SERVER_KEY)

if (NOT GVM_CA_CERTIFICATE)
  set (GVM_CA_CERTIFICATE "${GVM_STATE_DIR}/CA/cacert.pem")
else (NOT GVM_CA_CERTIFICATE)
  set (GVM_CA_CERTIFICATE "${GVM_CA_CERTIFICATE}")
endif (NOT GVM_CA_CERTIFICATE)

set (GSAD_CONFIG_DIR         "${SYSCONFDIR}/gvm/")

if (NOT GVM_RUN_DIR)
  set (GVM_RUN_DIR      "${LOCALSTATEDIR}/run")
endif (NOT GVM_RUN_DIR)

message ("-- Install prefix: ${CMAKE_INSTALL_PREFIX}")


if (SKIP_SRC)
  # ng has no documentation to build so skip if src should not be build
  set (SKIP_GSA ON)
  set (SKIP_GSAD ON)
endif (SKIP_SRC)

if (NOT SKIP_GSA)
  add_subdirectory (gsa)
endif (NOT SKIP_GSA)

if (NOT SKIP_GSAD)
  add_subdirectory (gsad)
endif (NOT SKIP_GSAD)

## Documentation

add_subdirectory (gsad/doc)

# vim: set ts=2 sw=2 tw=80:

=== gsa/CMakeLists.txt ===
# Copyright (C) 2016-2020 Greenbone Networks GmbH
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

find_package (Node 8.0 REQUIRED)
find_package (Yarn 1.0)

set (GSA_BUILD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/build)
set (GSA_DEST_DIR ${GSAD_DATA_DIR}/web)
set (GSA_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})

set (GSA_PKG_FILES
     ${GSA_SRC_DIR}/package.json)

if (NOT YARN_FOUND)
  MESSAGE (WARNING "Yarn package manager not found. Please install "
    "yarn for reproducible builds (see https://yarnpkg.com/en/docs/install). "
    "Trying to use npm instead.")
  find_package (Npm REQUIRED)
  set (INSTALLER ${NPM_EXECUTABLE})
else (NOT YARN_FOUND)
  message (STATUS "Found Yarn: ${YARN_EXECUTABLE}")
  set (INSTALLER ${YARN_EXECUTABLE})
  if (YARN_OFFLINE)
    set (INSTALLER_ARGS "--offline")
    MESSAGE( STATUS "Using Yarn in offline mode")
  endif (YARN_OFFLINE)
  list (APPEND GSA_PKG_FILES ${GSA_SRC_DIR}/yarn.lock)
endif (NOT YARN_FOUND)

set (GSA_STATIC_SRC_FILES
     ${GSA_SRC_DIR}/public/index.html)

set (GSA_JS_SRC_FILES
     ${GSA_SRC_DIR}/src/index.js
     ${GSA_SRC_DIR}/src/gmp/cancel.js
     ${GSA_SRC_DIR}/src/gmp/capabilities/capabilities.js
     ${GSA_SRC_DIR}/src/gmp/capabilities/everything.js
     ${GSA_SRC_DIR}/src/gmp/collection/collectioncounts.js
     ${GSA_SRC_DIR}/src/gmp/collection/parser.js
     ${GSA_SRC_DIR}/src/gmp/command.js
     ${GSA_SRC_DIR}/src/gmp/commands/agents.js
     ${GSA_SRC_DIR}/src/gmp/commands/alerts.js
     ${GSA_SRC_DIR}/src/gmp/commands/audits.js
     ${GSA_SRC_DIR}/src/gmp/commands/auth.js
     ${GSA_SRC_DIR}/src/gmp/commands/certbund.js
     ${GSA_SRC_DIR}/src/gmp/commands/cpes.js
     ${GSA_SRC_DIR}/src/gmp/commands/credentials.js
     ${GSA_SRC_DIR}/src/gmp/commands/cves.js
     ${GSA_SRC_DIR}/src/gmp/commands/cvsscalculator.js
     ${GSA_SRC_DIR}/src/gmp/commands/dashboards.js
     ${GSA_SRC_DIR}/src/gmp/commands/dfncert.js
     ${GSA_SRC_DIR}/src/gmp/commands/entities.js
     ${GSA_SRC_DIR}/src/gmp/commands/entity.js
     ${GSA_SRC_DIR}/src/gmp/commands/feedstatus.js
     ${GSA_SRC_DIR}/src/gmp/commands/filters.js
     ${GSA_SRC_DIR}/src/gmp/commands/gmp.js
     ${GSA_SRC_DIR}/src/gmp/commands/groups.js
     ${GSA_SRC_DIR}/src/gmp/commands/hosts.js
     ${GSA_SRC_DIR}/src/gmp/commands/http.js
     ${GSA_SRC_DIR}/src/gmp/commands/infoentities.js
     ${GSA_SRC_DIR}/src/gmp/commands/infoentity.js
     ${GSA_SRC_DIR}/src/gmp/commands/login.js
     ${GSA_SRC_DIR}/src/gmp/commands/notes.js
     ${GSA_SRC_DIR}/src/gmp/commands/nvt.js
     ${GSA_SRC_DIR}/src/gmp/commands/os.js
     ${GSA_SRC_DIR}/src/gmp/commands/ovaldefs.js
     ${GSA_SRC_DIR}/src/gmp/commands/overrides.js
     ${GSA_SRC_DIR}/src/gmp/commands/permissions.js
     ${GSA_SRC_DIR}/src/gmp/commands/policies.js
     ${GSA_SRC_DIR}/src/gmp/commands/portlists.js
     ${GSA_SRC_DIR}/src/gmp/commands/reportformats.js
     ${GSA_SRC_DIR}/src/gmp/commands/reports.js
     ${GSA_SRC_DIR}/src/gmp/commands/results.js
     ${GSA_SRC_DIR}/src/gmp/commands/roles.js
     ${GSA_SRC_DIR}/src/gmp/commands/scanconfigs.js
     ${GSA_SRC_DIR}/src/gmp/commands/scanners.js
     ${GSA_SRC_DIR}/src/gmp/commands/schedules.js
     ${GSA_SRC_DIR}/src/gmp/commands/secinfo.js
     ${GSA_SRC_DIR}/src/gmp/commands/tags.js
     ${GSA_SRC_DIR}/src/gmp/commands/targets.js
     ${GSA_SRC_DIR}/src/gmp/commands/tasks.js
     ${GSA_SRC_DIR}/src/gmp/commands/tickets.js
     ${GSA_SRC_DIR}/src/gmp/commands/tlscertificates.js
     ${GSA_SRC_DIR}/src/gmp/commands/trashcan.js
     ${GSA_SRC_DIR}/src/gmp/commands/users.js
     ${GSA_SRC_DIR}/src/gmp/commands/vulns.js
     ${GSA_SRC_DIR}/src/gmp/gmp.js
     ${GSA_SRC_DIR}/src/gmp/gmpsettings.js
     ${GSA_SRC_DIR}/src/gmp/http/gmp.js
     ${GSA_SRC_DIR}/src/gmp/http/http.js
     ${GSA_SRC_DIR}/src/gmp/http/rejection.js
     ${GSA_SRC_DIR}/src/gmp/http/response.js
     ${GSA_SRC_DIR}/src/gmp/http/transform/default.js
     ${GSA_SRC_DIR}/src/gmp/http/transform/fastxml.js
     ${GSA_SRC_DIR}/src/gmp/http/utils.js
     ${GSA_SRC_DIR}/src/gmp/index.js
     ${GSA_SRC_DIR}/src/gmp/locale/date.js
     ${GSA_SRC_DIR}/src/gmp/locale/detector.js
     ${GSA_SRC_DIR}/src/gmp/locale/lang.js
     ${GSA_SRC_DIR}/src/gmp/locale/languages.js
     ${GSA_SRC_DIR}/src/gmp/locale/index.js
     ${GSA_SRC_DIR}/src/gmp/log.js
     ${GSA_SRC_DIR}/src/gmp/model.js
     ${GSA_SRC_DIR}/src/gmp/models/actionresult.js
     ${GSA_SRC_DIR}/src/gmp/models/agent.js
     ${GSA_SRC_DIR}/src/gmp/models/alert.js
     ${GSA_SRC_DIR}/src/gmp/models/asset.js
     ${GSA_SRC_DIR}/src/gmp/models/audit.js
     ${GSA_SRC_DIR}/src/gmp/models/certbund.js
     ${GSA_SRC_DIR}/src/gmp/models/cpe.js
     ${GSA_SRC_DIR}/src/gmp/models/credential.js
     ${GSA_SRC_DIR}/src/gmp/models/cve.js
     ${GSA_SRC_DIR}/src/gmp/models/date.js
     ${GSA_SRC_DIR}/src/gmp/models/dfncert.js
     ${GSA_SRC_DIR}/src/gmp/models/event.js
     ${GSA_SRC_DIR}/src/gmp/models/filter.js
     ${GSA_SRC_DIR}/src/gmp/models/filter/convert.js
     ${GSA_SRC_DIR}/src/gmp/models/filter/filterterm.js
     ${GSA_SRC_DIR}/src/gmp/models/filter/keywords.js
     ${GSA_SRC_DIR}/src/gmp/models/filter/utils.js
     ${GSA_SRC_DIR}/src/gmp/models/group.js
     ${GSA_SRC_DIR}/src/gmp/models/host.js
     ${GSA_SRC_DIR}/src/gmp/models/info.js
     ${GSA_SRC_DIR}/src/gmp/models/login.js
     ${GSA_SRC_DIR}/src/gmp/models/note.js
     ${GSA_SRC_DIR}/src/gmp/models/nvt.js
     ${GSA_SRC_DIR}/src/gmp/models/os.js
     ${GSA_SRC_DIR}/src/gmp/models/ovaldef.js
     ${GSA_SRC_DIR}/src/gmp/models/override.js
     ${GSA_SRC_DIR}/src/gmp/models/permission.js
     ${GSA_SRC_DIR}/src/gmp/models/policy.js
     ${GSA_SRC_DIR}/src/gmp/models/portlist.js
     ${GSA_SRC_DIR}/src/gmp/models/reportformat.js
     ${GSA_SRC_DIR}/src/gmp/models/report.js
     ${GSA_SRC_DIR}/src/gmp/models/report/app.js
     ${GSA_SRC_DIR}/src/gmp/models/report/cve.js
     ${GSA_SRC_DIR}/src/gmp/models/report/host.js
     ${GSA_SRC_DIR}/src/gmp/models/report/os.js
     ${GSA_SRC_DIR}/src/gmp/models/report/parser.js
     ${GSA_SRC_DIR}/src/gmp/models/report/port.js
     ${GSA_SRC_DIR}/src/gmp/models/report/report.js
     ${GSA_SRC_DIR}/src/gmp/models/report/task.js
     ${GSA_SRC_DIR}/src/gmp/models/report/tlscertificate.js
     ${GSA_SRC_DIR}/src/gmp/models/result.js
     ${GSA_SRC_DIR}/src/gmp/models/role.js
     ${GSA_SRC_DIR}/src/gmp/models/scanconfig.js
     ${GSA_SRC_DIR}/src/gmp/models/scanner.js
     ${GSA_SRC_DIR}/src/gmp/models/schedule.js
     ${GSA_SRC_DIR}/src/gmp/models/secinfo.js
     ${GSA_SRC_DIR}/src/gmp/models/settings.js
     ${GSA_SRC_DIR}/src/gmp/models/tag.js
     ${GSA_SRC_DIR}/src/gmp/models/target.js
     ${GSA_SRC_DIR}/src/gmp/models/task.js
     ${GSA_SRC_DIR}/src/gmp/models/ticket.js
     ${GSA_SRC_DIR}/src/gmp/models/tlscertificate.js
     ${GSA_SRC_DIR}/src/gmp/models/user.js
     ${GSA_SRC_DIR}/src/gmp/models/vulnerability.js
     ${GSA_SRC_DIR}/src/gmp/parser.js
     ${GSA_SRC_DIR}/src/gmp/timezones.js
     ${GSA_SRC_DIR}/src/gmp/utils/array.js
     ${GSA_SRC_DIR}/src/gmp/utils/entitytype.js
     ${GSA_SRC_DIR}/src/gmp/utils/event.js
     ${GSA_SRC_DIR}/src/gmp/utils/id.js
     ${GSA_SRC_DIR}/src/gmp/utils/identity.js
     ${GSA_SRC_DIR}/src/gmp/utils/number.js
     ${GSA_SRC_DIR}/src/gmp/utils/object.js
     ${GSA_SRC_DIR}/src/gmp/utils/string.js
     ${GSA_SRC_DIR}/src/gmp/utils/trace.js
     ${GSA_SRC_DIR}/src/web/app.js
     ${GSA_SRC_DIR}/src/web/components/badge/badge.js
     ${GSA_SRC_DIR}/src/web/components/bar/compliancestatusbar.js
     ${GSA_SRC_DIR}/src/web/components/bar/menubar.js
     ${GSA_SRC_DIR}/src/web/components/bar/progressbar.js
     ${GSA_SRC_DIR}/src/web/components/bar/severitybar.js
     ${GSA_SRC_DIR}/src/web/components/bar/statusbar.js
     ${GSA_SRC_DIR}/src/web/components/bar/titlebar.js
     ${GSA_SRC_DIR}/src/web/components/bar/toolbar.js
     ${GSA_SRC_DIR}/src/web/components/chart/axis.js
     ${GSA_SRC_DIR}/src/web/components/chart/bar.js
     ${GSA_SRC_DIR}/src/web/components/chart/bubble.js
     ${GSA_SRC_DIR}/src/web/components/chart/donut.js
     ${GSA_SRC_DIR}/src/web/components/chart/donut/arc2d.js
     ${GSA_SRC_DIR}/src/web/components/chart/donut/arc3d.js
     ${GSA_SRC_DIR}/src/web/components/chart/donut/labels.js
     ${GSA_SRC_DIR}/src/web/components/chart/donut/paths.js
     ${GSA_SRC_DIR}/src/web/components/chart/donut/pie.js
     ${GSA_SRC_DIR}/src/web/components/chart/donut/proptypes.js
     ${GSA_SRC_DIR}/src/web/components/chart/group.js
     ${GSA_SRC_DIR}/src/web/components/chart/label.js
     ${GSA_SRC_DIR}/src/web/components/chart/legend.js
     ${GSA_SRC_DIR}/src/web/components/chart/line.js
     ${GSA_SRC_DIR}/src/web/components/chart/schedule.js
     ${GSA_SRC_DIR}/src/web/components/chart/svg.js
     ${GSA_SRC_DIR}/src/web/components/chart/tooltip.js
     ${GSA_SRC_DIR}/src/web/components/chart/topology.js
     ${GSA_SRC_DIR}/src/web/components/chart/utils/arc.js
     ${GSA_SRC_DIR}/src/web/components/chart/utils/constants.js
     ${GSA_SRC_DIR}/src/web/components/chart/utils/path.js
     ${GSA_SRC_DIR}/src/web/components/chart/utils/update.js
     ${GSA_SRC_DIR}/src/web/components/chart/wordcloud.js
     ${GSA_SRC_DIR}/src/web/components/comment/comment.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/controls.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/dashboard.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/created/createddisplay.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/created/createdtransform.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/createDisplay.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/cvss/cvssdisplay.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/cvss/cvsstabledisplay.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/cvss/cvsstransform.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/datadisplay.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/datadisplayicons.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/datatable.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/datatabledisplay.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/display.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/filterselection.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/severity/severityclassdisplay.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/severity/severityclasstabledisplay.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/severity/severityclasstransform.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/status/statusdisplay.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/utils.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/display/withFilterSelection.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/registry.js
     ${GSA_SRC_DIR}/src/web/components/dashboard/utils.js
     ${GSA_SRC_DIR}/src/web/components/dialog/button.js
     ${GSA_SRC_DIR}/src/web/components/dialog/composercontent.js
     ${GSA_SRC_DIR}/src/web/components/dialog/container.js
     ${GSA_SRC_DIR}/src/web/components/dialog/content.js
     ${GSA_SRC_DIR}/src/web/components/dialog/closebutton.js
     ${GSA_SRC_DIR}/src/web/components/dialog/dialog.js
     ${GSA_SRC_DIR}/src/web/components/dialog/error.js

=== gsad/CMakeLists.txt ===
# Copyright (C) 2017-2018 Greenbone Networks GmbH
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

## Files generated on installation

# generate compile_commands.json file
# see https://clang.llvm.org/docs/JSONCompilationDatabase.html
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

configure_file (src/gsad_log_conf.cmake_in src/gsad_log.conf)

## Install

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/src/gsad_log.conf
         DESTINATION ${GSAD_CONFIG_DIR})

add_subdirectory (src)
add_subdirectory (config)

# vim: set ts=2 sw=2 tw=80:

=== gsa/po/CMakeLists.txt ===
# Copyright (C) 2015-2020 Greenbone Networks GmbH
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

include (FindGettext)
include (FindPythonInterp)
include (FindPythonModule)

find_python_module(polib)

set (GSA_LOCALE_DIR ${GSA_SRC_DIR}/public/locales)

# Create targets for a language _LANG
macro (MAKE_TRANSLATION _LANG)
  # Files for installation
  # .json for JS
  add_custom_command (OUTPUT ${GSA_LOCALE_DIR}/gsa-${_LANG}.json
                      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gsa-${_LANG}.po
                      COMMAND ${PYTHON_EXECUTABLE} "${CMAKE_SOURCE_DIR}/tools/po2json"
                      ARGS ${CMAKE_CURRENT_SOURCE_DIR}/gsa-${_LANG}.po
                      ${GSA_LOCALE_DIR}/gsa-${_LANG}.json)

  add_custom_command (OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gsa-${_LANG}-merged.po
                      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsa.pot
                      COMMAND ${GETTEXT_MSGMERGE_EXECUTABLE}
                      ARGS ${CMAKE_CURRENT_SOURCE_DIR}/gsa-${_LANG}.po
                      ${CMAKE_CURRENT_BINARY_DIR}/gsa.pot
                      -o ${CMAKE_CURRENT_BINARY_DIR}/gsa-${_LANG}-merged.po)
endmacro ()

if (GETTEXT_FOUND)
  if (POLIB_FOUND)

    file (MAKE_DIRECTORY ${GSA_LOCALE_DIR})

    MAKE_TRANSLATION (ar)
    MAKE_TRANSLATION (de)
    MAKE_TRANSLATION (fr)
    MAKE_TRANSLATION (pt_BR)
    MAKE_TRANSLATION (ru)
    MAKE_TRANSLATION (tr)
    MAKE_TRANSLATION (zh_CN)
    MAKE_TRANSLATION (zh_TW)

    # Installed files
    add_custom_target (gettext-json
                       ALL
                       DEPENDS ${GSA_LOCALE_DIR}/gsa-ar.json
                       DEPENDS ${GSA_LOCALE_DIR}/gsa-de.json
                       DEPENDS ${GSA_LOCALE_DIR}/gsa-fr.json
                       DEPENDS ${GSA_LOCALE_DIR}/gsa-pt_BR.json
                       DEPENDS ${GSA_LOCALE_DIR}/gsa-ru.json
                       DEPENDS ${GSA_LOCALE_DIR}/gsa-tr.json
                       DEPENDS ${GSA_LOCALE_DIR}/gsa-zh_CN.json
                       DEPENDS ${GSA_LOCALE_DIR}/gsa-zh_TW.json
                       COMMENT "Created translation .json files")

    # Merged .po files
    add_custom_target (gettext-merge
                       DEPENDS gettext-js-merge
                       COMMENT "Merged translation .po files")

    add_custom_target (gettext-js-merge
                       DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsa.pot
                       DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsa-ar-merged.po
                       DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsa-de-merged.po
                       DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsa-fr-merged.po
                       DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsa-pt_BR-merged.po
                       DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsa-ru-merged.po
                       DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsa-tr-merged.po
                       DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsa-zh_CN-merged.po
                       DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsa-zh_TW-merged.po
                       COMMENT "Merged translation .po files for JS")

    # Template (.pot) files
    # All template files
    add_custom_target (gettext-pot
                       DEPENDS gettext-js-pot)

    # JS template files
    add_custom_target (gettext-js-pot
                       DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gsa.pot)

    add_custom_command (OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/gsa.pot
                        COMMAND "${CMAKE_SOURCE_DIR}/tools/js2pot"
                        ARGS    "${CMAKE_SOURCE_DIR}"
                                "${CMAKE_CURRENT_BINARY_DIR}/gsa.pot"
                                "${GSA_SRC_DIR}/src"
                        DEPENDS ${GSA_JS_SRC_FILES}
                        COMMENT "Creating translation template (.pot) file from JS")

    install (DIRECTORY
             ${GSA_LOCALE_DIR}
             DESTINATION ${GSA_DEST_DIR})

  else (POLIB_FOUND)
    message (WARNING "Could not build translation files: Python interpreter or polib Python module not found.")
  endif (POLIB_FOUND)

else (GETTEXT_FOUND)
  message (WARNING "Could not build translation files: gettext not found.")
endif (GETTEXT_FOUND)

=== gsad/config/CMakeLists.txt ===
# Copyright (C) 2019 Greenbone Networks GmbH
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

if (NOT SYSTEMD_SERVICE_DIR)
  set (SYSTEMD_SERVICE_DIR "${CMAKE_INSTALL_PREFIX}/lib/systemd/system")
endif (NOT SYSTEMD_SERVICE_DIR)

if (NOT DEFAULT_CONFIG_DIR)
  set (DEFAULT_CONFIG_DIR "${CMAKE_INSTALL_PREFIX}/etc/default")
endif (NOT DEFAULT_CONFIG_DIR)

if (NOT LOGROTATE_DIR)
  set (LOGROTATE_DIR "${CMAKE_INSTALL_PREFIX}/etc/logrotate.d")
endif (NOT LOGROTATE_DIR)

configure_file (gsad.service.in gsad.service)
configure_file (gsad.logrotate.in gsad.logrotate)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/gsad.service
         DESTINATION ${SYSTEMD_SERVICE_DIR}/)

install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/gsad.default
         DESTINATION ${DEFAULT_CONFIG_DIR}/ RENAME gsad)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/gsad.logrotate
         DESTINATION ${LOGROTATE_DIR}/ RENAME gsad)

=== gsad/doc/CMakeLists.txt ===
# Copyright (C) 2009-2018 Greenbone Networks GmbH
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

## build

set_directory_properties (PROPERTIES CLEAN_NO_CUSTOM true)
set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ".built-html;.built-html_full")

include (FindDoxygen)

# Configure Doxyfile with version number
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile_full.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_full)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile_xml.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_xml)

if (NOT DOXYGEN_EXECUTABLE)
  message (STATUS "WARNING: Doxygen is required to build the HTML docs.")
else (NOT DOXYGEN_EXECUTABLE)
  add_custom_target (doc COMMENT "Building documentation..."
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile ${CMAKE_CURRENT_BINARY_DIR}/.built-html)

  add_custom_command (OUTPUT .built-html
    COMMAND sh
    ARGS -c \"${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile && touch ${CMAKE_CURRENT_BINARY_DIR}/.built-html\;\"
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

  add_custom_target (doc-full COMMENT "Building documentation..."
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_full ${CMAKE_CURRENT_BINARY_DIR}/.built-html_full)

  add_custom_command (OUTPUT .built-html_full
    COMMAND sh
    ARGS -c \"${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_full && touch ${CMAKE_CURRENT_BINARY_DIR}/.built-html_full\;\"
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_full)

  add_custom_target (doc-xml COMMENT "Building documentation (XML)..."
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_xml ${CMAKE_CURRENT_BINARY_DIR}/.built-xml)

  add_custom_command (OUTPUT .built-xml
    COMMAND sh
    ARGS -c \"${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_xml && touch ${CMAKE_CURRENT_BINARY_DIR}/.built-xml\;\"
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_xml)
endif (NOT DOXYGEN_EXECUTABLE)

## Find xml2man

message (STATUS "Looking for xmltoman...")

find_program (XMLTOMAN_EXECUTABLE xmltoman
  PATHS /bin /usr/bin /usr/local/bin/
  DOC "xmltoman location")

message (STATUS "Looking for xmltoman... ${XMLTOMAN_EXECUTABLE}")

find_program (XMLMANTOHTML_EXECUTABLE xmlmantohtml
  PATHS /bin /usr/bin /usr/local/bin/
  DOC "xmlmantohtml location")

message (STATUS "Looking for xmlmantohtml... ${XMLMANTOHTML_EXECUTABLE}")

# FIX find_program seems to follow symlink
if (XMLMANTOHTML_EXECUTABLE)
  set (XMLMANTOHTML_EXECUTABLE xmlmantohtml)
endif (XMLMANTOHTML_EXECUTABLE)

if (XMLTOMAN_EXECUTABLE)
  add_custom_target (man COMMENT "Building manual page..."
    DEPENDS gsad.8)

  add_custom_command (OUTPUT gsad.8
    COMMAND sh
    ARGS -c \"${XMLTOMAN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/gsad.8.xml > ${CMAKE_CURRENT_BINARY_DIR}/gsad.8\;\"
    DEPENDS gsad.8.xml)
else (XMLTOMAN_EXECUTABLE)
  message (STATUS "WARNING: xmltoman is required to generate manpage.")
  add_custom_command (OUTPUT gsad.8
    COMMAND echo "[Error: xmltoman required to see manpage here]" > ${CMAKE_CURRENT_BINARY_DIR}/gsad.8)
endif (XMLTOMAN_EXECUTABLE)

if (XMLMANTOHTML_EXECUTABLE)
  add_custom_target (man-html COMMENT "Building manual page HTML..."
    DEPENDS gsad.html)

  add_custom_command (OUTPUT gsad.html
    COMMAND sh
    ARGS -c \"${XMLMANTOHTML_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/gsad.8.xml > ${CMAKE_CURRENT_BINARY_DIR}/gsad.html\;\"
    DEPENDS gsad.8.xml)
else (XMLMANTOHTML_EXECUTABLE)
  message (STATUS "WARNING: xmlmantohtml is required for manpage in HTML docs.")
  add_custom_command (OUTPUT gsad.html
    COMMAND echo "[Error: xmlmantohtml required to see manpage here]" > gsad.html)
endif (XMLMANTOHTML_EXECUTABLE)


## Install

install (FILES gsad.8
  DESTINATION ${DATADIR}/man/man8 )

=== gsad/src/CMakeLists.txt ===
# Copyright (C) 2009-2018 Greenbone Networks GmbH
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

# Needed for 'pkg_check_modules' function
include (FindPkgConfig)

if (NOT PKG_CONFIG_FOUND)
  message(FATAL_ERROR "pkg-config executable not found. Aborting.")
endif (NOT PKG_CONFIG_FOUND)

## Check for existence of required libraries
pkg_check_modules (LIBMICROHTTPD REQUIRED libmicrohttpd>=0.9.0)
pkg_check_modules (LIBXML REQUIRED libxml-2.0)
pkg_check_modules (GLIB REQUIRED glib-2.0>=2.42)
pkg_check_modules (LIBGVM_BASE REQUIRED libgvm_base>=10.0.0)
pkg_check_modules (LIBGVM_UTIL REQUIRED libgvm_util>=10.0.0)
pkg_check_modules (LIBGVM_GMP REQUIRED libgvm_gmp>=10.0.0)
pkg_check_modules (GNUTLS REQUIRED gnutls>=3.2.15)

message (STATUS "Looking for libgcrypt...")
find_library (LIBGCRYPT gcrypt)
if (NOT LIBGCRYPT)
  message (SEND_ERROR "The libgcrypt library is required.")
else (NOT LIBGCRYPT)
  message (STATUS "Looking for libgcrypt... ${LIBGCRYPT}")
  execute_process (COMMAND libgcrypt-config --libs
    OUTPUT_VARIABLE LIBGCRYPT_LDFLAGS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  execute_process (COMMAND libgcrypt-config --cflags
    OUTPUT_VARIABLE LIBGCRYPT_CFLAGS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
endif (NOT LIBGCRYPT)

if (NOT LIBMICROHTTPD_FOUND OR NOT LIBXML_FOUND OR NOT GLIB_FOUND OR
    (GTHREAD_REQUIRED AND NOT GTHREAD_FOUND) OR NOT
    LIBGVM_GMP_FOUND OR NOT GNUTLS_FOUND OR NOT
    LIBGCRYPT)
  message (FATAL_ERROR "One or more required libraries was not found "
    "(see message above), please install the missing "
    "libraries and run cmake again.")
endif (NOT LIBMICROHTTPD_FOUND OR NOT LIBXML_FOUND OR NOT GLIB_FOUND OR
  (GTHREAD_REQUIRED AND NOT GTHREAD_FOUND) OR NOT
  LIBGVM_GMP_FOUND OR NOT GNUTLS_FOUND OR NOT LIBGCRYPT)

## Program

set (HARDENING_FLAGS            "-D_FORTIFY_SOURCE=2 -fstack-protector")
set (LINKER_HARDENING_FLAGS     "-Wl,-z,relro -Wl,-z,now")

set (CMAKE_C_FLAGS              "${CMAKE_C_FLAGS} -Wall -Wformat -Wformat-security")

set (CMAKE_C_FLAGS_DEBUG        "${CMAKE_C_FLAGS_DEBUG} -Werror")
set (CMAKE_C_FLAGS_RELEASE      "${CMAKE_C_FLAGS_RELEASE} ${HARDENING_FLAGS}")

include_directories (${LIBMICROHTTPD_INCLUDE_DIRS} ${LIBXML_INCLUDE_DIRS}
                     ${GLIB_INCLUDE_DIRS}
                     ${LIBGVM_BASE_INCLUDE_DIRS}
                     ${LIBGVM_UTIL_INCLUDE_DIRS}
                     ${LIBGVM_GMP_INCLUDE_DIRS}
                     ${GNUTLS_INCLUDE_DIRS})

find_package (Threads)

## Program

add_executable (gsad
                gsad.c
                gsad_base.c
                gsad_cmd.c
                gsad_credentials.c
                gsad_gmp.c
                gsad_gmp_arguments.c
                gsad_gmp_request.c
                gsad_http.c
                gsad_http_handler.c
                gsad_i18n.c
                gsad_session.c
                gsad_settings.c
                gsad_user.c
                utils.c
                validator.c)

target_link_libraries (gsad ${LIBMICROHTTPD_LDFLAGS}
                            ${GTHREAD_LDFLAGS}
                            ${GLIB_LDFLAGS}
                            ${LIBXML_LDFLAGS}
                            ${LIBGCRYPT_LDFLAGS}
                            ${GNUTLS_LDFLAGS}
                            ${LIBGVM_BASE_LDFLAGS}
                            ${LIBGVM_UTIL_LDFLAGS}
                            ${LIBGVM_GMP_LDFLAGS}
                            ${LIBGVM_GMP_LDFLAGS}
                            ${CMAKE_THREAD_LIBS_INIT}
                            ${LINKER_HARDENING_FLAGS}
                       )
set_target_properties (gsad PROPERTIES LINKER_LANGUAGE C)

if (GSAD_VERSION)
  add_definitions (-DGSAD_VERSION="${GSAD_VERSION}")
endif (GSAD_VERSION)

if (NOT CMAKE_BUILD_TYPE MATCHES "Release")
  # If we got GIT_REVISION at configure time,
  # assume we can get it at build time as well
  if (GIT_REVISION)
    # a custom target that is always built
    add_custom_target (revisiontag ALL)

    # creates gitrevision.h using cmake script
    add_custom_command (TARGET revisiontag COMMAND ${CMAKE_COMMAND}
                        -DSOURCE_DIR=${CMAKE_SOURCE_DIR}
                        -P ${CMAKE_SOURCE_DIR}/cmake/GetGit.cmake)

    # explicitly say that the executable depends on custom target
    add_dependencies (gsad revisiontag)

    # include the output directory, where the gitrevision.h file is generated
    include_directories (${CMAKE_CURRENT_BINARY_DIR})
    add_definitions (-DGIT_REV_AVAILABLE)
  endif (GIT_REVISION)
endif (NOT CMAKE_BUILD_TYPE MATCHES "Release")

if (GVM_SERVER_CERTIFICATE)
  add_definitions (-DGVM_SERVER_CERTIFICATE="${GVM_SERVER_CERTIFICATE}")
endif (GVM_SERVER_CERTIFICATE)

if (GVM_SERVER_KEY)
  add_definitions (-DGVM_SERVER_KEY="${GVM_SERVER_KEY}")
endif (GVM_SERVER_KEY)

if (GVM_CA_CERTIFICATE)
  add_definitions (-DGVM_CA_CERTIFICATE="${GVM_CA_CERTIFICATE}")
endif (GVM_CA_CERTIFICATE)

if (GVM_RUN_DIR)
  add_definitions (-DGVM_RUN_DIR="${GVM_RUN_DIR}")
endif (GVM_RUN_DIR)

if (GSAD_DATA_DIR)
  add_definitions (-DGSAD_DATA_DIR="${GSAD_DATA_DIR}")
endif (GSAD_DATA_DIR)

if (GSAD_PID_DIR)
  add_definitions (-DGSAD_PID_DIR="${GSAD_PID_DIR}")
endif (GSAD_PID_DIR)

if (GSAD_CONFIG_DIR)
  add_definitions (-DGSAD_CONFIG_DIR="${GSAD_CONFIG_DIR}")
endif (GSAD_CONFIG_DIR)

if (GSAD_LOCALE_DIR)
  add_definitions (-DGSAD_LOCALE_DIR="${GSAD_LOCALE_DIR}")
endif (GSAD_LOCALE_DIR)

if (GSAD_CHROOT_LOCALE_DIR)
  add_definitions (-DGSAD_CHROOT_LOCALE_DIR="${GSAD_CHROOT_LOCALE_DIR}")
endif (GSAD_CHROOT_LOCALE_DIR)

add_definitions (-DGVM_OS_NAME="${CMAKE_SYSTEM}")
add_definitions (-DPREFIX="${CMAKE_INSTALL_PREFIX}")

## Install

install (TARGETS gsad
         RUNTIME DESTINATION ${SBINDIR}
         LIBRARY DESTINATION ${LIBDIR}
         ARCHIVE DESTINATION ${LIBDIR}/static)

## Static analysis

add_custom_target (cppcheck COMMENT "Running cppcheck..."
                   COMMAND sh -c \"cppcheck ${CMAKE_CURRENT_SOURCE_DIR}\")

add_custom_target (check COMMENT "Checking code...")
add_dependencies (check cppcheck)

## Tag files

set (C_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*.c")
add_custom_target (etags COMMENT "Building TAGS..."
                   COMMAND etags ${C_FILES})
add_custom_target (ctags COMMENT "Building tags..."
                   COMMAND ctags ${C_FILES})
add_custom_target (tags COMMENT "Building tags files...")
add_dependencies (tags etags ctags)

## End

=== PKGBUILD ===
# Maintainer  : Christian Rebischke <chris.rebischke@archlinux.org>
# Maintainer  : Levente Polyak <anthraxx[at]archlinux[dot]org>
# Contributor : Daniel Micay <danielmicay@gmail.com>
_pkgname='gsa'
pkgname='greenbone-security-assistant'
conflicts=('gsa')
provides=('gsa')
replaces=('gsa')
pkgver=9.0.1
pkgrel=1
pkgdesc='Greenbone Security Assistant (gsa) - OpenVAS web frontend'
url="https://github.com/greenbone/gsa"
license=('GPL')
arch=('x86_64')
depends=('libmicrohttpd' 'gvm-libs' 'libxslt')
makedepends=('cmake' 'doxygen' 'xmltoman' 'git' 'nodejs' 'yarn')
groups=('greenbone-vulnerability-manager')
backup=('etc/openvas/gsad_log.conf')
source=("${_pkgname}-${pkgver}.tar.gz::https://github.com/greenbone/gsa/archive/v${pkgver}.tar.gz"
        "https://github.com/greenbone/gsa/releases/download/v${pkgver}/gsa-${pkgver}.tar.gz.sig")
sha512sums=('688bde97722f31416406e43230253c05dc8d05eb9fea6d8fd084ec4e748b67bab238f78cc11534e4fc948d911e468d43b5be0b224f17959db5e59faae7f5d086'
            'SKIP')
validpgpkeys=(
              '8AE4BE429B60A59B311C2E739823FAA60ED1E580' # GVM Transfer Integrity
)
changelog=CHANGELOG.md

build() {
  cd "${_pkgname}-${pkgver}"
  cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr \
    -DSYSCONFDIR=/etc -DLOCALSTATEDIR=/var . -DSBINDIR=/usr/bin
  make
}

package() {
  cd "${_pkgname}-${pkgver}"
  make DESTDIR="${pkgdir}" install
}
